/**
 * Programløsning på prosjektoppgave Vår 2022 i PROG1003.
 * 
 * NB!!-----------------------------------------------------!!
 * Dette prosjektet er laget for Linux, det burde også fungere
 * for Microsoft Windows 10 men innlesning av data fra CLI
 * kan dog ha uønsket atferd som "bricker" programmet.
 * NB!!-----------------------------------------------------!!
 * 
 * Programmet holder oversikt over buss, bane ruter og stoppesteder. 
 * En rute består av flere stoppesteder. Man kan lage nye stoppesteder
 * som legges inn i programmet som da senere kan brukes i Ruter.
 * En rute er enten en buss rute eller en bane rute.
 * På en rute så må en tid bli gitt mellom hvert stoppested.
 * Når en rute er ferdig laget kan man skrive ut en rutetabell for den
 * valgte ruten for ett spesifikt stoppested.
 * Man kan søke på en spesifikk rute for å få detaljert informasjon om
 * en spesifikk rute.
 * Man kan søke på et spesifikt stoppested for å se hvilke stoppesteder den 
 * har som naboer og tiden det tar for og komme til disse naboene.
 * Programmet tillater at man kan legge til eller fjerne stoppesteder
 * fra en eksisterende rute.
 * 
 * Alle stoppesteder og ruter blir lagret til fil når man avslutter
 * programmet. Den lagrede dataen blir hentent inn igjen i programmet 
 * når det starter.
 * 
 * Tilgjenglige kommandoer:
 * 
 * S N - Nytt stoppested
 * S A - Skriv alle stoppesteder
 * S E - Søk på spesifikk stoppested
 * R N - Ny rute
 * R A - Skriv kort alle ruter
 * R E - Endre rute
 * R B - Rute beskrivelse
 * R T - Rutetabell
 * Q - Avslutt
 * 
 * @file main.cpp
 * @author Andreas Blakli
 * @version 1.0
 * @date 07.04.2022
 * 
 */

#include "globaleFunksjoner.h"
#include "ruter.h"
#include "stoppesteder.h"

Stoppesteder* gStoppesteder;
Ruter* gRuter;

/**
 * Hoved programmet.
 * 
 * @see meny() - i globaleFunksjoner.
 * @see ryddOppMinne() - i globaleFunksjoner.
 */
int main() {
    gStoppesteder = new Stoppesteder;
    gRuter = new Ruter;
    
    // Meny som styrer programmet
    meny();
    // Fjerner pekere fra minne
    ryddOppMinne();

    return 0;
}
