#ifndef __STOPPESTED_H
#define __STOPPESTED_H

#include <fstream>
#include <iostream>
#include <string>
#include <vector>

#include "hjelpeFunksjoner.h"
#include "konstanter.h"
#include "lesData3.h"

/**
 * Stoppested klasse.
 *
 * Har datamedlemmene:
 *      navn - String med navnet på stoppestedet
 *      indexNaboStoppene - Liste over nabostoppene sine indekser.
 *      antallMinutterTilNaboStopp - Liste over tiden mellom nabostoppene.
 */
class Stoppested {
   private:
    HjelpeFunksjoner hjelp;
    // Navnet på stoppestedet
    std::string navn;
    // Liste over nabostoppene sine indekser
    std::vector<int> indexNaboStoppene;
    // Liste over tiden mellom nabostoppene
    std::vector<int> antallMinutterTilNaboStopp;

   public:
    Stoppested();
    Stoppested(const std::string& navn, const bool& leggeTilTid);
    Stoppested(const int& index, const std::string& navn);
    ~Stoppested();
    void skrivData();
    void skrivNavn();
    void lesData();
    std::string hentNavn();
    void skrivDataMedNaboer(std::vector<Stoppested*> alleStoppesteder);
    int hentTidNaboStopp();
    int hentNaboStoppIndex(const bool& siste);
    void leggTilNaboStopp(const int& index, const int& minutter);
    void lesTid();
    void leggTilIndex(const int& index);
    void leggTilTid(const int& minutter);
    void slettVectorer();
    int hentIndex();
    void fjernForsteNabo();
    void fjernSisteNabo();
    void leggTilNaboFremst(const int& index, const int& tid);
    void leggTilNaboBakerst(const int& index, const int& tid);
    int hentAntallStoppestedVector();
    int hentTidForsteNabo();
    void lesFraFil(std::ifstream& inn);
    void skrivTilFil(std::ofstream& ut);
};
#endif  //__STOPPESTED_H